;
;  **** *** *** ***** * *  ' S
;  **   *-* *-*   *   ***    
;  **** * * *  *  *   * *    
;
;  ********************************************************************* 
;  ***							      **	
;  **							      ***	
;  ****************  *****  ****   ****   *****  **       **  **********
;                **  *   *  *   *  *   *  *   *   **     **          ***
;               ***  *   *  ****   ****   *   *    ** * **            **
;  ****************  *****  *   *  *   *  *****     ** **  *************
;
;-----------------------------------------------------------------------
;************** ORIENS PART * THE COPPER MAN PRESENTATION *     ********
;-----------------------------------------------------------------------

;-----------------------------------------------------------------------
ORG $20000
LOAD $20000
;-----------------------------------------------------------------------
;-----------------------------------------------------------------------

ST:
;-----------------------------------------------------------------------
	BSR	SAVE_ALL	
;-----------------------------------------------------------------------
	LEA	$40000,A0			; EFFACE MEM
	LEA	$80000,A1			; .
CLEAR:	CLR.L	(A0)+				; .
	CMP.L	A0,A1				; .
	BNE.S	CLEAR				; .


	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#0,$DFF064
	MOVE.W	#22,$DFF066
	MOVE.L	#NOW1,$DFF050
	MOVE.L	#$6C000+[286*40]+12,$DFF054
	MOVE.W	#45*64+9,$DFF058
	BSR	TEST

	MOVE.L	#$89F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#0,$DFF064
	MOVE.W	#24,$DFF066
	MOVE.L	#NOW2,$DFF050
	MOVE.L	#$70000+[246*40]+13,$DFF054
	MOVE.W	#39*64+8,$DFF058
	BSR	TEST

	MOVE.L	#$09F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#0,$DFF064
	MOVE.W	#26,$DFF066
	MOVE.L	#NOW3,$DFF050
	MOVE.L	#$74000+[216*40]+14,$DFF054
	MOVE.W	#33*64+7,$DFF058
	BSR	TEST

	MOVE.L	#$49F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#0,$DFF064
	MOVE.W	#28,$DFF066
	MOVE.L	#NOW4,$DFF050
	MOVE.L	#$78000+[193*40]+14,$DFF054
	MOVE.W	#30*64+6,$DFF058
	BSR	TEST

	MOVE.L	#$89F00000,$DFF040
	MOVE.L	#$FFFFFFFF,$DFF044
	MOVE.W	#0,$DFF064
	MOVE.W	#28,$DFF066
	MOVE.L	#NOW5,$DFF050
	MOVE.L	#$7C000+[176*40]+15,$DFF054
	MOVE.W	#26*64+6,$DFF058
	BSR	TEST
;-----------------------------------------------------------------------
	LEA	TABLE5,A1		; MET COPPER POUR ONLY UN PLAN
	BSR	PUT_COL

	LEA	$DFF000,A6		
	MOVE.W	#$7FFF,$9A(A6)	
	MOVE.W	#$7FFF,$96(A6)	
	MOVE.L	#$1A7039C7,$8E(A6)
	CLR.L	$102(A6)	
	MOVE.W	#0,$DFF108
	MOVE.W	#0,$DFF10A
	MOVE.L	#$003800D0,$92(A6)
	MOVE.L	#COPP,$DFF080	;   INIT ET LANCEMENT DE LA COPPER
	CLR.W	$DFF088
;-----------------------------------------------------------------------
	move.l	#irq,$6c	
;	move.w	#$20,96(a6)

	MOVE.W	#%1100000000010000,$9A(A6)
	MOVE.W	#%1000011111000000,$96(A6)
;		  5432109876543210
;	move.w	#$c010,$9a(a6)	
;	move.w	#$83c0,$96(a6)	
;-----------------------------------------------------------------------
ATTEN:				
	BTST	#6,$BFE001	
	BNE	ATTEN		
	BSR	RESTORE_ALL	
RTS
;-----------------------------------------------------------------------
;-----------------------------------------------------------------------
IRQ:
	MOVE.L	D0,-(SP)	
	MOVE.W	$DFF01C,D0	
	AND.W	$DFF01E,D0	
	BTST	#4,D0		
	BEQ	FINIRQ		

	BSR	SCROLL1

	BSR	FONDU

	MOVE.W	#$10,$DFF09C
FINIRQ:
	MOVE.L	(SP)+,D0
RTE
;-----------------------------------------------------------------------
TEST:
	BTST	#14,$DFF002
	BNE	TEST
RTS
;-----------------------------------------------------------------------
PUT_COP_IN:
	LEA	PUT_COP+6,A0
	LEA	RECU_DATAS,A1

	MOVE.W	#30,D0
PUT_IT:	MOVE.W	(A1)+,(A0)
	ADD.L	#4,A0
	DBRA D0,PUT_IT
RTS
;-----------------------------------------------------------------------
OK_DO_IT:		DC.W	0
COMPTEUR_COULEUR:	DC.W	0
;-----------------------------------------------------------------------
;	FONDU
;-----------------------------------------------------------------------
FONDU:
	CMP.W	#1,OK_DO_IT
	BNE	PAS_FONDU

	BSR	FLASH_DOWN
	BSR	PUT_COP_IN
PAS_FONDU:
RTS

FLASH_UP:				; ARRIVEE DE LA COULEUR 
	CLR.W	D5

	LEA	COULEURS_DATAS,A4
	LEA	RECU_DATAS,A3

	MOVE.W	#30,D6			; 30 DANS D5
FLASH01:
	MOVE.W	(A4)+,D0
					; D0 COUL DE DEPART
BSR	TEST_1ER_COMPOSANT
BSR	TEST_2EM_COMPOSANT
BSR	TEST_3EM_COMPOSANT

	MOVE.W	D0,(A3)+
DBRA	D6,FLASH01
	ADD.W	#1,COMPTEUR_COULEUR	;
FIN_FLASH1:
RTS
;****************************************************************
TEST_1ER_COMPOSANT:
	MOVE.W	D0,D1
	AND.W	#$000F,D1

	CMP.W	COMPTEUR_COULEUR,D1	; LE COMPARE AVEC COMPTEUR
	BMI	END_COMPOSANT_1		; SI AU DESSUS ALORS RESTE

	MOVE.W	COMPTEUR_COULEUR,D1	; SINON CONTINUE AVEC COMPTEUR

	AND.W	#$0FF0,D0		; 
	ADD.W	D1,D0			; REMET LES AUTRES
END_COMPOSANT_1:	
RTS
;****************************************************************
TEST_2EM_COMPOSANT:
	MOVE.W	D0,D1
	AND.W	#$00F0,D1
	LSR.W	#4,D1

	CMP.W	COMPTEUR_COULEUR,D1
	BMI	END_COMPOSANT_2

	MOVE.W	COMPTEUR_COULEUR,D1
	LSL.W	#4,D1
	AND.W	#$0F0F,D0
	ADD.W	D1,D0
END_COMPOSANT_2:	
RTS
;****************************************************************
TEST_3EM_COMPOSANT:
	MOVE.W	D0,D1
	AND.W	#$0F00,D1
	LSR.W	#8,D1
	CMP.W	COMPTEUR_COULEUR,D1
	BMI	END_COMPOSANT_3
	MOVE.W	COMPTEUR_COULEUR,D1
	LSL.W	#8,D1
	AND.W	#$00FF,D0
	ADD.W	D1,D0
END_COMPOSANT_3:	
RTS
;----------------------------------------------------------------
;****************************************************************
FLASH_DOWN:				; ARRIVEE DE LA COULEUR 
	CLR.W	D5

	LEA	COULEURS_DATAS,A4
	LEA	RECU_DATAS,A3

	MOVE.W	#30,D6			; 30 DANS D5
FLASH011:
	MOVE.W	(A4)+,D0
					; D0 COUL DE DEPART
BSR	TEST_1ER_COMPOSANT
BSR	TEST_2EM_COMPOSANT
BSR	TEST_3EM_COMPOSANT

	MOVE.W	D0,(A3)+

DBRA	D6,FLASH011

	SUB.W	#1,COMPTEUR_COULEUR	;
	CMP.W	#-1,COMPTEUR_COULEUR
	BNE	FIN_FLASH55
	CLR.W	OK_DO_IT
FIN_FLASH55:
RTS
;-----------------------------------------------------------------------
COULEURS_DATAS:	DC.W	C1,C2,C1
		DC.W	C3,C1,C2,C1
		DC.W	C4,C1,C2,C1
		DC.W	C3,C1,C2,C1
		DC.W	C5,C1,C2,C1
		DC.W	C3,C1,C2,C1
		DC.W	C4,C1,C2,C1
		DC.W	C3,C1,C2,C1
RECU_DATAS:		BLK.W	31,0
;-----------------------------------------------------------------------
;-----------------------------------------------------------------------
SAVE_ALL:
	MOVE.B #%10000111,$BFD100
	MOVE.L 4,A6
	JSR -132(A6)
	MOVE.L $6C,SAVE_VECTEUR_IRQ
	MOVE.W $DFF01C,SAVE_INTENA
	OR.W #$C000,SAVE_INTENA
	MOVE.W $DFF002,SAVE_DMACON
	OR.W #$8100,SAVE_DMACON
RTS
;-----------------------------------------------------------------------
RESTORE_ALL:
	MOVE.L SAVE_VECTEUR_IRQ,$6C
	MOVE.W #$7FFF,$DFF09A	
	MOVE.W SAVE_INTENA,$DFF09A
	MOVE.W #$7FFF,$DFF096
	MOVE.W SAVE_DMACON,$DFF096
	MOVE.L 4,A6
	LEA NAME_GLIB,A1
	MOVEQ #0,D0
	JSR -552(A6)
	MOVE.L D0,A0
	MOVE.L 38(A0),$DFF080
	CLR.W $DFF088
	MOVE.L D0,A1
	JSR -414(A6)
	JSR -138(A6)
RTS
SAVE_INTENA:DC.W 0
SAVE_DMACON:DC.W 0
SAVE_VECTEUR_IRQ:DC.L 0
name_glib:dc.b "graphics.library",0
even
;-----------------------------------------------------------------------
;VIT1>A0
;POS1>A1
;BASE>A2
;COP>A5
;-----------------------------------------------------------------------
SCROLL1:

CONT8:
	CMP.L	#$01280000,POS1
	BNE	CONT9

	MOVE.W	#1,OK_DO_IT
	MOVE.W	#13,COMPTEUR_COULEUR

;	BSR	RESET_ALL
CONT9:
	CMP.L	#$01480000,POS1
	BNE	CONT10

	BSR	RESET_ALL
	LEA	TABLE5,A1		; MET COPPER POUR ONLY UN PLAN
	BSR	PUT_COL
CONT10:

	LEA	VIT1,A0
	LEA	POS1,A1
	LEA	$6C000,A2
	LEA	COP1,A5
	BSR	PUT

	LEA	VIT2,A0
	LEA	POS2,A1
	LEA	$70000,A2
	LEA	COP2,A5
	BSR	PUT

	LEA	VIT3,A0
	LEA	POS3,A1
	LEA	$74000,A2
	LEA	COP3,A5
	BSR	PUT

	LEA	VIT4,A0
	LEA	POS4,A1
	LEA	$78000,A2
	LEA	COP4,A5
	BSR	PUT

	LEA	VIT5,A0
	LEA	POS5,A1
	LEA	$7C000,A2
	LEA	COP5,A5
	BSR	PUT
RTS

PUT:
	CLR.L	D0
	CLR.L	D1

	MOVE.L	(A0),D0
	ADD.L	D0,(A1)			; +1 LIGNE

	MOVE.L	(A1),D0			; PREND LIGNE
	SWAP	D0			; DEDUIT L'ADRRESSE RELATIVE
	MULU	#40,D0

	MOVE.L	A2,D1
	ADD.L	D0,D1			; DEDUIT L'ADDRESSE ABSOLUE

	MOVE.W	D1,6(A5)
	SWAP	D1
	MOVE.W	D1,2(A5)
RTS
;-----------------------------------------------------------------------
RESET_ALL:	CLR.L	POS1
		CLR.L	POS2
		CLR.L	POS3
		CLR.L	POS4
		CLR.L	POS5
RTS
;-----------------------------------------------------------------------
PUT_COL:MOVE.W	#31,D0
	LEA	PUT_COP,A0
BB:	MOVE.W	(A1)+,2(A0)
	ADD.L	#4,A0
DBRA	D0,BB
RTS
;-----------------------------------------------------------------------
VIT1:	DC.L	$00010000	;1
POS1:	DC.L	0
VIT2:	DC.L	$0000C000	;C
POS2:	DC.L	0	
VIT3:	DC.L	$00009000	;9
POS3:	DC.L	0
VIT4:	DC.L	$00006C00	;9C
POS4:	DC.L	0	
VIT5:	DC.L	$00005000	;51
POS5:	DC.L	0
;-----------------------------------------------------------------------
TABLE5:		DC.W	CF,C1,C2,C1
		DC.W	C3,C1,C2,C1

		DC.W	C4,C1,C2,C1
		DC.W	C3,C1,C2,C1

		DC.W	C5,C1,C2,C1
		DC.W	C3,C1,C2,C1

		DC.W	C4,C1,C2,C1
		DC.W	C3,C1,C2,C1
;-----------------------------------------------------------------------
COPP:
			; 0
NU=0

COLN1=$0
COLN2=$1
COLN3=$2
COLN4=$3
COLN5=$4

C1=$000F
C2=$010C
C3=$0209
C4=$0306
C5=$0403

C1A=$000C
C2A=$0009
C3A=$0006
;C4A=$0003
C4A=COLN5
;C5A=$0100
C5A=COLN5

C1B=$0009
C2B=$0006
C3B=$0003
C4B=COLN4
C5B=COLN4

C1C=$0006
C2C=$0003
C3C=COLN3
C4C=COLN3
C5C=COLN3

C1D=$0003
C2D=COLN2
C3D=COLN2
C4D=COLN2
C5D=COLN2

C1E=COLN1
C2E=COLN1
C3E=COLN1
C4E=COLN1
C5E=COLN1

CF=0

PUT_COP:	DC.W	$0180,CF,$0182,C1,$0184,C2,$0186,C1
		DC.W	$0188,C3,$018A,C1,$018C,C2,$018E,C1
		DC.W	$0190,C4,$0192,C1,$0194,C2,$0196,C1
		DC.W	$0198,C3,$019A,C1,$019C,C2,$019E,C1
		DC.W	$01A0,C5,$01A2,C1,$01A4,C2,$01A6,C1
		DC.W	$01A8,C3,$01AA,C1,$01AC,C2,$01AE,C1
		DC.W	$01B0,C4,$01B2,C1,$01B4,C2,$01B6,C1
		DC.W	$01B8,C3,$01BA,C1,$01BC,C2,$01BE,C1
	
		DC.L	$01005200	

COP1:		DC.L	$00E00006,$00E2C000
COP2:		DC.L	$00E40007,$00E60000
COP3:		DC.L	$00E80007,$00EA4000
COP4:		DC.L	$00EC0007,$00EE8000
COP5:		DC.L	$00F00007,$00F2C000
;-----------------------------------------------------------------------
		DC.L	$C507FFFE
		DC.W	$0180,COLN5,$0182,C1A,$0184,C2A,$0186,C1A
		DC.W	$0188,C3A,$018A,C1A,$018C,C2A,$018E,C1A
		DC.W	$0190,C4A,$0192,C1A,$0194,C2A,$0196,C1A
		DC.W	$0198,C3A,$019A,C1A,$019C,C2A,$019E,C1A
		DC.W	$01A0,C5A,$01A2,C1A,$01A4,C2A,$01A6,C1A
		DC.W	$01A8,C3A,$01AA,C1A,$01AC,C2A,$01AE,C1A
		DC.W	$01B0,C4A,$01B2,C1A,$01B4,C2A,$01B6,C1A
		DC.W	$01B8,C3A,$01BA,C1A,$01BC,C2A,$01BE,C1A

		DC.L	$C707FFFE
		DC.W	$0180,COLN4,$0182,C1B,$0184,C2B,$0186,C1B
		DC.W	$0188,C3B,$018A,C1B,$018C,C2B,$018E,C1B
		DC.W	$0190,C4B,$0192,C1B,$0194,C2B,$0196,C1B
		DC.W	$0198,C3B,$019A,C1B,$019C,C2B,$019E,C1B
		DC.W	$01A0,C5B,$01A2,C1B,$01A4,C2B,$01A6,C1B
		DC.W	$01A8,C3B,$01AA,C1B,$01AC,C2B,$01AE,C1B
		DC.W	$01B0,C4B,$01B2,C1B,$01B4,C2B,$01B6,C1B
		DC.W	$01B8,C3B,$01BA,C1B,$01BC,C2B,$01BE,C1B

		DC.L	$C907FFFE
		DC.W	$0180,COLN3,$0182,C1C,$0184,C2C,$0186,C1C
		DC.W	$0188,C3C,$018A,C1C,$018C,C2C,$018E,C1C
		DC.W	$0190,C4C,$0192,C1C,$0194,C2C,$0196,C1C
		DC.W	$0198,C3C,$019A,C1C,$019C,C2C,$019E,C1C
		DC.W	$01A0,C5C,$01A2,C1C,$01A4,C2C,$01A6,C1C
		DC.W	$01A8,C3C,$01AA,C1C,$01AC,C2C,$01AE,C1C
		DC.W	$01B0,C4C,$01B2,C1C,$01B4,C2C,$01B6,C1C
		DC.W	$01B8,C3C,$01BA,C1C,$01BC,C2C,$01BE,C1C

		DC.L	$CB07FFFE
		DC.W	$0180,COLN2,$0182,C1D,$0184,C2D,$0186,C1D
		DC.W	$0188,C3D,$018A,C1D,$018C,C2D,$018E,C1D
		DC.W	$0190,C4D,$0192,C1D,$0194,C2D,$0196,C1D
		DC.W	$0198,C3D,$019A,C1D,$019C,C2D,$019E,C1D
		DC.W	$01A0,C5D,$01A2,C1D,$01A4,C2D,$01A6,C1D
		DC.W	$01A8,C3D,$01AA,C1D,$01AC,C2D,$01AE,C1D
		DC.W	$01B0,C4D,$01B2,C1D,$01B4,C2D,$01B6,C1D
		DC.W	$01B8,C3D,$01BA,C1D,$01BC,C2D,$01BE,C1D

		DC.L	$CE07FFFE
		DC.W	$0180,COLN1,$0182,C1E,$0184,C2E,$0186,C1E
		DC.W	$0188,C3E,$018A,C1E,$018C,C2E,$018E,C1E
		DC.W	$0190,C4E,$0192,C1E,$0194,C2E,$0196,C1E
		DC.W	$0198,C3E,$019A,C1E,$019C,C2E,$019E,C1E
		DC.W	$01A0,C5E,$01A2,C1E,$01A4,C2E,$01A6,C1E
		DC.W	$01A8,C3E,$01AA,C1E,$01AC,C2E,$01AE,C1E
		DC.W	$01B0,C4E,$01B2,C1E,$01B4,C2E,$01B6,C1E
		DC.W	$01B8,C3E,$01BA,C1E,$01BC,C2E,$01BE,C1E


;-----------------------------------------------------------------------
		DC.L	$009C8010,$FFFFFFFE	; THE END OF COPPER



NOW1:BLK.B	810
NOW2:BLK.B	624
NOW3:BLK.B	462
NOW4:BLK.B	360
NOW5:BLK.B	312
;NOW6:BLK.B	250

END:

>EXTERN "RAM:NOW1.BT",NOW1
>EXTERN "RAM:NOW2.BT",NOW2
>EXTERN "RAM:NOW3.BT",NOW3
>EXTERN "RAM:NOW4.BT",NOW4
>EXTERN "RAM:NOW5.BT",NOW5
;>EXTERN "NOW6.BT",NOW6

